<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Cache;

//--------------------------------------------------

//--------------------------------------------------

use stdClass;

class ApcCache extends AbstractCache
{

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys


//--------------------------------------------------
// Protected:Propertys


//--------------------------------------------------
// Constants


//--------------------------------------------------
    /**
     * No Information Found
     * @since 1.0
     */
    public function __construct(int $ttl = 0, array $config = array())
    {
        $config = array_merge(array(), $config);

        parent::__construct($ttl, $config);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function exists(string $path, ?string $environment = null): bool
    {
        $key = $this->key($path, $environment);

        if (function_exists("apc_exists")) {
            return apc_exists($key);
        }

        return false;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function read(string $path, ?string $environment = null): stdClass
    {
        $key = $this->key($path, $environment);

        if (function_exists("apc_fetch")) {
            $value = apc_fetch($key, $success);

            if ($success) {
                return json_decode($value);
            }
        }

        return new stdClass();
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function write(string $path, stdClass $content, ?string $environment = null): bool
    {
        $key = $this->key($path, $environment);

        if (function_exists("apc_store")) {
            return apc_store($key, json_encode($content), (time() + $this->getTTL()));
        }

        return false;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    private function getFile(string $key): string
    {
        return "/dev/null";
    }

//--------------------------------------------------

}

//--------------------------------------------------

?>