<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Entity;

//--------------------------------------------------

use Bbg\ProductAssets\CDN\AbstractCDN;
use stdClass;

//--------------------------------------------------

class BeforeAfterEntity extends AbstractEntity
{

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys
    private $beforeUrl;
    private $beforeCaption;
    private $beforeHeight;
    private $beforeWidth;

    private $afterUrl;
    private $afterCaption;
    private $afterHeight;
    private $afterWidth;

//--------------------------------------------------
// Protected:Propertys


//--------------------------------------------------
// Constants


//--------------------------------------------------
    /**
     * No Information Found
     * @since 1.0
     */
    public function __construct(?stdClass $data = null, ?string $path = null, ?AbstractCDN $cdn = null)
    {
        if (is_null($data)) {
            return true;
        }

        parent::__construct($data, $path, $cdn);

        if ((isset($data->before)) && (is_object($data->before))) {
            $dataObject = $data->before;

            $this
                ->setBeforeUrl((isset($dataObject->url) ? $dataObject->url : ""))
                ->setBeforeCaption((isset($dataObject->caption) ? $dataObject->caption : ""))
                ->setBeforeHeight((isset($dataObject->height) ? $dataObject->height : 0))
                ->setBeforeWidth((isset($dataObject->width) ? $dataObject->width : 0));
        }

        if ((isset($data->after)) && (is_object($data->after))) {
            $dataObject = $data->after;

            $this
                ->setAfterUrl((isset($dataObject->url) ? $dataObject->url : ""))
                ->setAfterCaption((isset($dataObject->caption) ? $dataObject->caption : ""))
                ->setAfterHeight((isset($dataObject->height) ? $dataObject->height : 0))
                ->setAfterWidth((isset($dataObject->width) ? $dataObject->width : 0));
        }
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getBeforeUrl(?array $args = null): string
    {
        return $this->getFullPath($this->beforeUrl, $args);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setBeforeUrl(string $value): BeforeAfterEntity
    {
        $this->beforeUrl = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getBeforeCaption(): string
    {
        return $this->beforeCaption;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setBeforeCaption(string $value): BeforeAfterEntity
    {
        $this->beforeCaption = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getBeforeHeight(): int
    {
        return $this->beforeHeight;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setBeforeHeight(int $value): BeforeAfterEntity
    {
        $this->beforeHeight = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getBeforeWidth(): int
    {
        return $this->beforeWidth;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setBeforeWidth(int $value): BeforeAfterEntity
    {
        $this->beforeWidth = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getAfterUrl(?array $args = null): string
    {
        return $this->getFullPath($this->afterUrl, $args);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setAfterUrl(string $value): BeforeAfterEntity
    {
        $this->afterUrl = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getAfterCaption(): string
    {
        return $this->afterCaption;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setAfterCaption(string $value): BeforeAfterEntity
    {
        $this->afterCaption = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getAfterHeight(): int
    {
        return $this->afterHeight;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setAfterHeight(int $value): BeforeAfterEntity
    {
        $this->afterHeight = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getAfterWidth(): int
    {
        return $this->afterWidth;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setAfterWidth(int $value): BeforeAfterEntity
    {
        $this->afterWidth = $value;

        return $this;
    }

//--------------------------------------------------

}

//--------------------------------------------------

?>