<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Entity;

//--------------------------------------------------

use Bbg\ProductAssets\CDN\AbstractCDN;
use stdClass;

//--------------------------------------------------

class ImageEntity extends AbstractEntity
{

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys
    private $opaque;
    private $variant;

//--------------------------------------------------
// Protected:Propertys


//--------------------------------------------------
// Constants


//--------------------------------------------------
    /**
     * No Information Found
     * @since 1.0
     */
    public function __construct(?stdClass $data = null, ?string $path = null, ?AbstractCDN $cdn = null)
    {
        if (is_null($data)) {
            return true;
        }

        parent::__construct($data, $path, $cdn);

        $this
            ->setUrl((isset($data->url) ? $data->url : ""))
            ->setOpaque((isset($data->opaque) ? $data->opaque : false))
            ->setVariant((isset($data->variant) ? $data->variant : 0));
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getOpaque(): bool
    {
        return $this->opaque;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setOpaque(bool $value): ImageEntity
    {
        $this->opaque = $value;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getVariant(int $value): int
    {
        return $this->variant;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setVariant(int $value): ImageEntity
    {
        $this->variant = $value;

        return $this;
    }

//--------------------------------------------------

}

//--------------------------------------------------

?>